package at.jku.ssw.psw2.ue02.demo;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.Arrays;
import java.util.stream.Collectors;

@SuppressWarnings("unused")
public class PrettyPrinter {
	
	public static void print(Class<?>  c) {
		
		println("package " + c.getPackage().getName() + ";");
		print(Modifier.toString(c.getModifiers()) + " class " +  c.getSimpleName()); 
		print(" extends " + c.getSuperclass().getSimpleName() + " ");
		if (c.getInterfaces().length != 0) {
			print("implements ");
			for (Class<?> ifc : c.getInterfaces()) {
				print(ifc.getSimpleName() + " "); 
			}
			
		}
		println("{ "); 
		for (Field f : c.getDeclaredFields()) {
			println("    " + Modifier.toString(f.getModifiers()) +
					" " + f.getType().getSimpleName() + " " + f.getName() + ";"); 
		}
		for (Method m : c.getMethods()) {
			print("    " + Modifier.toString(m.getModifiers()) +
					" " + m.getReturnType().getSimpleName() + " " + m.getName() + "(");
			print(Arrays.stream(m.getParameters())
					.map(p -> p.getClass().getSimpleName() + " " + p.getName())
					.collect(Collectors.joining(", "))); 
			println(");"); 
			
		}
		println("}"); 
		
	}
	
	private static void print(String text) {
		System.out.print(text);
	}

	private static void println(String text) {
		System.out.println(text);
	}
	
	private static void format(String format, Object params) {
		System.out.format(format, params); 
		
	}
	
	public static void main(String[] args) {
		print(Person.class); 
	}

}
